﻿using Microsoft.AspNetCore.Mvc;
using Send_Email_MailKit_Core_MVC.Models;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

using System.IO;
using MimeKit;
using MailKit.Net.Smtp;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;

namespace Send_Email_MailKit_Core_MVC.Controllers
{
    public class HomeController : Controller
    {
        public IConfiguration Configuration { get; set; }

        public HomeController(IConfiguration _configuration)
        {
            Configuration = _configuration;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Index(EmailModel model)
        {
            this.SendEmail(model.To, model.Email, model.Password, model.Subject, model.Body, model.Attachment);
            ViewBag.Message = "Email Sent.";
            return View();
        }

        private void SendEmail(string to, string from, string password, string subject, string body, IFormFile postedFile)
        {
            string host = this.Configuration.GetValue<string>("Smtp:Server");
            int port = this.Configuration.GetValue<int>("Smtp:Port");
            string ccAddress = this.Configuration.GetValue<string>("Smtp:CcAddress");
            string bccAddress = this.Configuration.GetValue<string>("Smtp:BccAddress");

            using (MimeMessage mm = new MimeMessage())
            {
                mm.From.Add(new MailboxAddress("Sender", from));
                mm.To.Add(new MailboxAddress("Recipient", to));
                mm.Subject = subject;
                mm.Cc.Add(new MailboxAddress("Cc", ccAddress));
                mm.Bcc.Add(new MailboxAddress("Bcc", bccAddress));
                BodyBuilder builder = new BodyBuilder();
                builder.TextBody = body;
                if (postedFile != null)
                {
                    string fileName = Path.GetFileName(postedFile.FileName);
                    builder.Attachments.Add(fileName, postedFile.OpenReadStream());
                }
                mm.Body = builder.ToMessageBody();
                using (SmtpClient smtp = new SmtpClient())
                {
                    smtp.Connect(host, port);
                    smtp.Authenticate(from, password);
                    smtp.Send(mm);
                    smtp.Disconnect(true);
                }
            }
        }
    }
}
